Add a new customer - Fabric

Add a new customer

cURL

curl --request POST \
  --url https://api.fabric.inc/v3/Customers \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": {
    "firstName": "Pat",
    "lastName": "Doe",
    "title": "Dr.",
    "middleName": "E",
    "suffix": "Jr."
  },
  "emailAddress": "test@example.com",
  "phone": {
    "number": 15555551234,
    "type": "MOBILE"
  },
  "externalId": "1231012312-312-31231asda",
  "additionalAttributes": {
    "type": "shopper"
  }
}
'

Python

import requests

url = "https://api.fabric.inc/v3/Customers"

payload = {
    "name": {
        "firstName": "Pat",
        "lastName": "Doe",
        "title": "Dr.",
        "middleName": "E",
        "suffix": "Jr."
    },
    "emailAddress": "test@example.com",
    "phone": {
        "number": 15555551234,
        "type": "MOBILE"
    },
    "externalId": "1231012312-312-31231asda",
    "additionalAttributes": { "type": "shopper" }
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    name: {
      firstName: 'Pat',
      lastName: 'Doe',
      title: 'Dr.',
      middleName: 'E',
      suffix: 'Jr.'
    },
    emailAddress: 'test@example.com',
    phone: {number: 15555551234, type: 'MOBILE'},
    externalId: '1231012312-312-31231asda',
    additionalAttributes: {type: 'shopper'}
  })
};

fetch('https://api.fabric.inc/v3/Customers', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

<?php

$curl = curl_init();

curl_setopt_array($curl, [\
  CURLOPT_URL => "https://api.fabric.inc/v3/Customers",\
  CURLOPT_RETURNTRANSFER => true,\
  CURLOPT_ENCODING => "",\
  CURLOPT_MAXREDIRS => 10,\
  CURLOPT_TIMEOUT => 30,\
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,\
  CURLOPT_CUSTOMREQUEST => "POST",\
  CURLOPT_POSTFIELDS => json_encode([\
    'name' => [\
        'firstName' => 'Pat',\
        'lastName' => 'Doe',\
        'title' => 'Dr.',\
        'middleName' => 'E',\
        'suffix' => 'Jr.'\
    ],\
    'emailAddress' => 'test@example.com',\
    'phone' => [\
        'number' => 15555551234,\
        'type' => 'MOBILE'\
    ],\
    'externalId' => '1231012312-312-31231asda',\
    'additionalAttributes' => [\
        'type' => 'shopper'\
    ]\
  ]),\
  CURLOPT_HTTPHEADER => [\
    "Authorization: Bearer <token>",\
    "Content-Type: application/json"\
  ],\
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Golang

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/Customers"

payload := strings.NewReader("{\n  \"name\": {\n    \"firstName\": \"Pat\",\n    \"lastName\": \"Doe\",\n    \"title\": \"Dr.\",\n    \"middleName\": \"E\",\n    \"suffix\": \"Jr.\"\n  },\n  \"emailAddress\": \"test@example.com\",\n  \"phone\": {\n    \"number\": 15555551234,\n    \"type\": \"MOBILE\"\n  },\n  \"externalId\": \"1231012312-312-31231asda\",\n  \"additionalAttributes\": {\n    \"type\": \"shopper\"\n  }\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Example Response

Success (201)

{
  "id": "61df41892bf06d00092d0d8a",
  "name": {
    "firstName": "Pat",
    "lastName": "Doe",
    "title": "Dr.",
    "middleName": "E",
    "suffix": "Jr."
  },
  "emailAddress": "test@example.com",
  "isDeleted": false,
  "createdAt": "2023-08-30T23:20:42.822Z",
  "updatedAt": "2023-08-30T23:20:42.822Z",
  "status": "ACTIVE",
  "phone": {
    "number": 15555551234,
    "type": "MOBILE"
  },
  "externalId": "1231012312-312-31231asda",
  "additionalAttributes": {
    "middleName": "user"
  },
  "deletedAt": "2023-08-30T23:20:42.822Z"
}

Error Responses

Invalid Account
{
  "type": "INVALID_ACCOUNT_PROVIDED",
  "message": "Invalid account provided for the request."
}
Request Denied
{
  "type": "REQUEST_DENIED",
  "message": "Forbidden"
}
Internal Server Error
{
  "type": "INTERNAL_SERVER_ERROR",
  "message": "Internal server error"
}